import { r as registerInstance, h, d as getElement } from './core-4636ab56.js';
import './_commonjsHelpers-4ab098b6.js';
import { r as resolveJson } from './utils-ae529797.js';
import { _ } from './lodash-62c1633d.js';

const PwcDynamicFormContent = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
    }
    itemsWatchHandler(items) {
        this.resolvedItems = resolveJson(items);
    }
    async getFieldRefs() {
        return this.fieldRefs;
    }
    componentWillLoad() {
        this.itemsWatchHandler(this.items);
    }
    handleFieldRef(fieldConfig, fieldRef) {
        if (fieldRef) {
            this.fieldRefs = _.unionBy(this.fieldRefs, [fieldRef], i => i.config.name);
        }
        else {
            _.remove(this.fieldRefs, i => i.config.name === fieldConfig.name);
        }
    }
    constructField(fieldConfig) {
        let nameIndexer = 0;
        const nameGenerator = name => {
            return name || "pwc-dynamic-form___generated-name-" + nameIndexer++;
        };
        fieldConfig.name = nameGenerator(fieldConfig.name);
        return (h("pwc-dynamic-form-field", { config: fieldConfig, ref: this.handleFieldRef.bind(this, fieldConfig) }));
    }
    render() {
        if (this.resolvedItems) {
            // we are mutating the config, therefore we have to clone it to leave the user input intact.
            const resolvedItemsClone = _.cloneDeep(this.resolvedItems);
            return resolvedItemsClone.map(this.constructField.bind(this));
        }
        else {
            return "";
        }
    }
    get rootElement() { return getElement(this); }
    static get watchers() { return {
        "items": ["itemsWatchHandler"]
    }; }
    static get style() { return ""; }
};

export { PwcDynamicFormContent as pwc_dynamic_form_content };
